image: python:latest

stages:
  - static analysis
  - test
  - deploy

before_script:
  - python --version
  - python -m pip install --upgrade pip
  - pip install -r requirements.txt
  
#pylint:
#  stage: static analysis
#  script:
#    - pylint -d C0301 careu/*.py
#  coverage: '/^TOTAL.+?(\d+\%)$/'
  
unit-test: 
  stage: test
  script:  
    - python -m pip install Django 
    - python manage.py test 
    
Test_Coverage:
  stage: test
  before_script:
    - wget -q -O - https://dl-ssl.google.com/linux/linux_signing_key.pub | apt-key add -
    - echo "deb http://dl.google.com/linux/chrome/deb/ stable main" > /etc/apt/sources.list.d/google.list
    - pip install -r requirements.txt
    - python manage.py makemigrations
    - python manage.py migrate
    - apt-get update -qq && apt-get install -y -qq unzip
    - apt-get install -y google-chrome-stable
    - apt-get install -y xvfb
    - wget https://chromedriver.storage.googleapis.com/2.32/chromedriver_linux64.zip
    - unzip chromedriver_linux64.zip
    - python manage.py collectstatic --no-input
    - python manage.py runserver 8000 &
  when: on_success
  script:
    - coverage run manage.py test
    - coverage report -m


Deployment:
  image: ruby:2.4
  stage: deploy
  before_script:
    - gem install dpl
    - wget -qO- https://cli-assets.heroku.com/install-ubuntu.sh | sh
  script:
    - dpl --provider=heroku --app=$HEROKU_APPNAME --api-key=$HEROKU_APIKEY
    - export HEROKU_API_KEY=$HEROKU_APIKEY
    - heroku run --app $HEROKU_APPNAME python manage.py migrate
  environment:
    name: production
    url: $HEROKU_APP_HOST